/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lecturequiz.teacherclient;
import  java.util.prefs.*;

/**
 *
 * @author avenger
 */
public class ConfigurationManager {
    private static ConfigurationManager _instance = null;

    // The preferences object used to store configurations on the computer
    private Preferences prefs;


    // Keys used in the configration file
    private static final String WEB_SERVICE_URL = "WebServiceURL";
    private static final String TEXTRENDERER_USE_MIPMAP = "TextRendererUseMipMap";

    private ConfigurationManager() {
        prefs = Preferences.userRoot().node("LQTeacherClient/Configuration");

        // Load all variables
        webServiceURL = prefs.get(WEB_SERVICE_URL, "http://avenger.fenicore.net:8080/LectureQuiz/LectureQuizService?wsdl");
        textRendererUseMipMap = prefs.getBoolean(TEXTRENDERER_USE_MIPMAP, true);

    }

    /**
     * Get an instance of the configuration settings
     * @return
     */
    public static synchronized ConfigurationManager getInstance() {
        if(_instance == null)
            _instance = new ConfigurationManager();
        return _instance;
    }

    // Wether we should use mipmaping when rendering text
    private boolean textRendererUseMipMap = true;
    public boolean getTextRendererUseMipMap() {
        return textRendererUseMipMap;
    }

    public void setTextRendererUseMipMap(boolean b) {
        textRendererUseMipMap = b;
    }

    private String webServiceURL;
    public String getWebServiceURL() {
        return webServiceURL;
    }

    public void setWebServiceURL(String url) {
        webServiceURL = url;
    }

    /**
     * Saves the current configuration
     */
    public void save() {
        prefs.put(WEB_SERVICE_URL, webServiceURL);
        prefs.putBoolean(TEXTRENDERER_USE_MIPMAP,textRendererUseMipMap);
    }
}
