/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * QuizEditor.java
 *
 * Created on Apr 27, 2010, 9:02:16 PM
 */

package lecturequiz.teacherclient;

import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.AbstractTableModel;
import javax.xml.ws.Holder;
import lecturequiz.server.service.FullQuestionInfo;
import lecturequiz.server.service.QuizInfo;
import lecturequiz.server.service.FullQuizInfo;
import lecturequiz.teacherclient.service.ConnectionManager;
import lecturequiz.teacherclient.utils.ComboItem;

/**
 *
 * @author avenger
 */
public class QuizEditor extends javax.swing.JPanel {

    // The data of the current quiz we are editing
    private FullQuizInfo currentQuiz;

    // True if the current quiz has changes since last save
    private boolean hasChanges;

    /** Creates new form QuizEditor */
    public QuizEditor() {
        initComponents();
        
        final QuizEditor pThis = this;

        quizzesList.addListSelectionListener(new ListSelectionListener() {

            public void valueChanged(ListSelectionEvent e) {
                pThis.quizzesListSelectionChanged(e);
            }
        });

        currentQuiz = null;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        btnBack = new javax.swing.JButton();
        btnSave = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        btnNewQuiz = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        quizzesList = new javax.swing.JList();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        txtQuizName = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        txtQuizDesc = new javax.swing.JTextField();
        btnDelQuestion = new javax.swing.JButton();
        btnAddQuestion = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        questionsTable = new javax.swing.JTable();

        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(lecturequiz.teacherclient.LQTeacherClientApp.class).getContext().getResourceMap(QuizEditor.class);
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        btnBack.setText(resourceMap.getString("btnBack.text")); // NOI18N
        btnBack.setName("btnBack"); // NOI18N
        btnBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBackActionPerformed(evt);
            }
        });

        btnSave.setText(resourceMap.getString("btnSave.text")); // NOI18N
        btnSave.setName("btnSave"); // NOI18N
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });

        jPanel1.setName("jPanel1"); // NOI18N

        btnNewQuiz.setText(resourceMap.getString("btnNewQuiz.text")); // NOI18N
        btnNewQuiz.setName("btnNewQuiz"); // NOI18N
        btnNewQuiz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNewQuizActionPerformed(evt);
            }
        });

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        quizzesList.setName("quizzesList"); // NOI18N
        jScrollPane1.setViewportView(quizzesList);

        jPanel2.setName("jPanel2"); // NOI18N

        jPanel3.setName("jPanel3"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        txtQuizName.setText(resourceMap.getString("txtQuizName.text")); // NOI18N
        txtQuizName.setName("txtQuizName"); // NOI18N
        txtQuizName.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtQuizNameKeyTyped(evt);
            }
        });

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        txtQuizDesc.setText(resourceMap.getString("txtQuizDesc.text")); // NOI18N
        txtQuizDesc.setName("txtQuizDesc"); // NOI18N
        txtQuizDesc.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtQuizDescKeyTyped(evt);
            }
        });

        btnDelQuestion.setText(resourceMap.getString("btnDelQuestion.text")); // NOI18N
        btnDelQuestion.setToolTipText(resourceMap.getString("btnDelQuestion.toolTipText")); // NOI18N
        btnDelQuestion.setName("btnDelQuestion"); // NOI18N
        btnDelQuestion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDelQuestionActionPerformed(evt);
            }
        });

        btnAddQuestion.setText(resourceMap.getString("btnAddQuestion.text")); // NOI18N
        btnAddQuestion.setToolTipText(resourceMap.getString("btnAddQuestion.toolTipText")); // NOI18N
        btnAddQuestion.setName("btnAddQuestion"); // NOI18N
        btnAddQuestion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddQuestionActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addGap(123, 123, 123)
                        .addComponent(jLabel4)
                        .addContainerGap(345, Short.MAX_VALUE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(txtQuizName, javax.swing.GroupLayout.PREFERRED_SIZE, 186, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(txtQuizDesc, javax.swing.GroupLayout.PREFERRED_SIZE, 188, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 182, Short.MAX_VALUE)
                        .addComponent(btnAddQuestion)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnDelQuestion))))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtQuizName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtQuizDesc, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap(38, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnDelQuestion)
                    .addComponent(btnAddQuestion)))
        );

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        questionsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "Question", "Answer"
            }
        ));
        questionsTable.setName("questionsTable"); // NOI18N
        jScrollPane2.setViewportView(questionsTable);
        questionsTable.getColumnModel().getColumn(0).setHeaderValue(resourceMap.getString("questionsTable.columnModel.title0")); // NOI18N
        questionsTable.getColumnModel().getColumn(1).setHeaderValue(resourceMap.getString("questionsTable.columnModel.title1")); // NOI18N
        questionsTable.getColumnModel().getColumn(2).setHeaderValue(resourceMap.getString("questionsTable.columnModel.title2")); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 669, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 299, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(btnNewQuiz, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 305, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnNewQuiz)
                        .addContainerGap())
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(btnBack)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnSave))
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnSave)
                    .addComponent(btnBack))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBackActionPerformed
        if(hasChanges) {
            switch(JOptionPane.showConfirmDialog(this, "The current quiz have changes, do you want to save?",
                    "Lecture Quiz 2.0", JOptionPane.YES_NO_CANCEL_OPTION)) {
                case JOptionPane.YES_OPTION:
                    if(!saveQuiz())
                        return;
                    break;

                case JOptionPane.CANCEL_OPTION:
                    return;
                    
                case JOptionPane.NO_OPTION:
                default:
                    break;
            }
        }
        MainMenu.getInstance().setPanel(MainMenu.PANEL.MAIN_PANEL);
    }//GEN-LAST:event_btnBackActionPerformed

    private void btnDelQuestionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDelQuestionActionPerformed
        if(questionsTable.getSelectedRows().length == 0) {
            JOptionPane.showMessageDialog(this, "No question selected");
            return;
        }

        int row = questionsTable.getSelectedRow();
        currentQuiz.getQuestions().remove(row);

        questionsTable.setModel(new QuestionsTableModel((currentQuiz.getQuestions())));

        setHasChanges(true);
    }//GEN-LAST:event_btnDelQuestionActionPerformed

    private void btnAddQuestionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddQuestionActionPerformed
        AddQuestionDialog dialog = new AddQuestionDialog(null, true);
        dialog.setVisible(true);

        if(dialog.getDialogResult() == JOptionPane.OK_OPTION) {
            FullQuestionInfo nfo = dialog.getQuestion();

            currentQuiz.getQuestions().add(nfo);
            questionsTable.setModel(new QuestionsTableModel(currentQuiz.getQuestions()));

            setHasChanges(true);
        }
    }//GEN-LAST:event_btnAddQuestionActionPerformed

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        saveQuiz();
    }//GEN-LAST:event_btnSaveActionPerformed

    private void txtQuizNameKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtQuizNameKeyTyped
        setHasChanges(true);
    }//GEN-LAST:event_txtQuizNameKeyTyped

    private void txtQuizDescKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtQuizDescKeyTyped
        setHasChanges(true);
    }//GEN-LAST:event_txtQuizDescKeyTyped

    private void btnNewQuizActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNewQuizActionPerformed
        if(hasChanges) {
            switch(JOptionPane.showConfirmDialog(this, "The current quiz have changes, do you want to save?",
                    "Lecture Quiz 2.0", JOptionPane.YES_NO_CANCEL_OPTION)) {
                case JOptionPane.YES_OPTION:
                    if(!saveQuiz())
                        return;
                    break;

                case JOptionPane.CANCEL_OPTION:
                    return;

                case JOptionPane.NO_OPTION:
                default:
                    break;
            }
        }

        currentQuiz = new FullQuizInfo();
        currentQuiz.getQuestions().clear();
        currentQuiz.setId(0);
        txtQuizName.setText("New quiz");
        txtQuizDesc.setText("");
        questionsTable.setModel(new QuestionsTableModel(currentQuiz.getQuestions()));
        enableEditComponents();

        setHasChanges(true);

    }//GEN-LAST:event_btnNewQuizActionPerformed

    private void setHasChanges(boolean b) {
        hasChanges = b;
        btnSave.setEnabled(b);
    }

    /**
     * Retrieves the list of quizzes and makes sure the user can edit them.
     * @return True if the init was successfull, false otherwise
     */
    public boolean init() {
        // Get the list of quizzes from the server
        Holder<List<QuizInfo>> quizzes = new Holder<List<QuizInfo>>();
        if(ConnectionManager.getInstance().getPort().getAvailableQuizzes(quizzes) != 0) {
            JOptionPane.showMessageDialog(this, "Could not get available quizzes");
            return false;
        }

        // Populate the list
        Vector<ComboItem<Integer>> items = new Vector<ComboItem<Integer>>();
        
        for(int i = 0; i < quizzes.value.size(); i++) {
            QuizInfo qi = quizzes.value.get(i);
            items.add(new ComboItem<Integer>(qi.getName(),qi.getId()));
        }

        quizzesList.setListData(items);
        quizzesList.clearSelection();
        questionsTable.setModel(new QuestionsTableModel(null));
        questionsTable.clearSelection();
        disableEditComponents();
        currentQuiz = null;

        return true;
    }

    /**
     * Fired when the quiz list selection changes
     * @param e event arguments
     */
    private void quizzesListSelectionChanged(ListSelectionEvent e) {
        if(hasChanges) {
            if (JOptionPane.showConfirmDialog(this, "The current quiz have changes, do you want to save?",
                    "Lecture Quiz 2.0", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                saveQuiz();
            }
        }

        // Get the quiz info from the server and display it
        ComboItem<Integer> selectedItem = (ComboItem<Integer>)quizzesList.getSelectedValue();
        if(selectedItem == null) {
            disableEditComponents();
            return;
        }

        Holder<FullQuizInfo> quizInfo = new Holder<FullQuizInfo>();
        ConnectionManager.getInstance().getPort().getQuiz(selectedItem.getId(), quizInfo);

        currentQuiz = quizInfo.value;

        txtQuizName.setText(currentQuiz.getName());
        txtQuizDesc.setText(currentQuiz.getDescription());

        questionsTable.setModel(new QuestionsTableModel(currentQuiz.getQuestions()));

        enableEditComponents();
        setHasChanges(false);
    }

    /**
     * Disables all the components used to edit a quiz
     */
    private void disableEditComponents() {
        txtQuizName.setEnabled(false);
        txtQuizDesc.setEnabled(false);
        questionsTable.setEnabled(false);
        btnSave.setEnabled(false);
        btnAddQuestion.setEnabled(false);
        btnDelQuestion.setEnabled(false);
    }
    /**
     * Enables all the components used to edit a quiz
     */
    private void enableEditComponents() {
        txtQuizName.setEnabled(true);
        txtQuizDesc.setEnabled(true);
        questionsTable.setEnabled(true);
        btnSave.setEnabled(true);
        btnAddQuestion.setEnabled(true);
        btnDelQuestion.setEnabled(true);
    }

    /**
     * Saves the current quiz
     * @return True if the save was successfull, false otherwise
     */
    private boolean saveQuiz() {
        currentQuiz.setName(txtQuizName.getText());
        currentQuiz.setDescription(txtQuizDesc.getText());

        int ret;
        if((ret = ConnectionManager.getInstance().getPort().saveQuiz(currentQuiz)) != 0) {
            JOptionPane.showMessageDialog(this, "Could not save quiz properly. Error code: " + ret);
            return false;
        }

        setHasChanges(false);

        // Check if we should update the list of quizzes
        if(currentQuiz.getId() == 0) {
            init();
        } else {
            // To make sure we update the quiz-list with newly added questions' IDs etc
            // we reload the current quiz
            quizzesListSelectionChanged(null);
        }

        return true;
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddQuestion;
    private javax.swing.JButton btnBack;
    private javax.swing.JButton btnDelQuestion;
    private javax.swing.JButton btnNewQuiz;
    private javax.swing.JButton btnSave;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable questionsTable;
    private javax.swing.JList quizzesList;
    private javax.swing.JTextField txtQuizDesc;
    private javax.swing.JTextField txtQuizName;
    // End of variables declaration//GEN-END:variables

}

class QuestionsTableModel extends AbstractTableModel {
    List<FullQuestionInfo> data;

    public QuestionsTableModel(List<FullQuestionInfo> data) {
        super();

        this.data = data;

        if(this.data == null)
            this.data = new ArrayList<FullQuestionInfo>();
    }

    public int getRowCount() {
        return data.size();
    }

    public int getColumnCount() {
        return 3;
    }

    @Override
    public String getColumnName(int index) {
        switch(index) {
            case 0:
                return "ID";

            case 1:
                return "Question";

            case 2:
                return "Answer";

            default:
                return null;
        }
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        switch(columnIndex) {
            case 0:
                if(data.get(rowIndex).getId() == 0)
                    return "New";
                else
                    return data.get(rowIndex).getId();

            case 1:
                return data.get(rowIndex).getText();

            case 2:
                FullQuestionInfo fqi = data.get(rowIndex);
                for(int i = 0; i < fqi.getAnswers().size(); i++) {
                    if(fqi.getCorrectAnswer() == fqi.getAnswers().get(i).getId())
                        return data.get(rowIndex).getAnswers().get(i).getText();
                }

                return null;
                
            default:
                throw new NullPointerException("Column index out of bounds");
        }
    }

}