/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lecturequiz.teacherclient.gamemodes;

import java.awt.BorderLayout;
import javax.swing.JComponent;

/**
 *
 * @author knutant
 */
public abstract class AbstractGameMode {
    
    // The parent component
    protected JComponent parent;

    // The renderer for this game mode
    protected AbstractGameRenderer renderer = null;

    /**
     * Constructor
     * @param parent The parent component to add render-components to
     */
    public AbstractGameMode(JComponent parent) {
        this.parent = parent;
        this.parent.setLayout(new BorderLayout());
        
        createRenderer();
    }
    /**
     * Called when a quiz is started from the UI
     * @param quizId the ID of the quiz started
     * @param quizCode the quiz code of the quiz started
     */
    public abstract void startQuiz(int quizId, String quizCode);

    /**
     * Starts the next question in the quiz
     */
    public abstract void nextQuestion();

    /**
     * Performs cleanup when the game is destroyed
     */
    public abstract void cleanup();

    /**
     * Creates the renderer for this game mode
     */
    protected abstract void createRenderer();
}
