/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lecturequiz.teacherclient.gamemodes;

import java.util.List;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLEventListener;
import lecturequiz.server.service.QuestionInfo;
import lecturequiz.server.service.StatisticsEntry;
import lecturequiz.server.service.GameStatus;

/**
 *
 * @author avenger
 */
public abstract class AbstractGameRenderer extends GLCanvas implements GLEventListener  {

    /**
     * Constructor, sets up the GL event listener and draw size
     * @param width Width of the drawing area
     * @param height Height of the drawing area
     */
    public AbstractGameRenderer(int width, int height) {
        super();

        setSize(width,height);
        addGLEventListener(this);
    }

    /**
     * Tells the renderer to show the welcome screen with the supplied info
     * @param gameStatus The status of the game to show on the welcome screen
     */
    public abstract void showWelcomeScreen(GameStatus gameStatus);

    /**
     * Tells the renderer to show the question supplied
     * @param info the question to render
     */
    public abstract void showQuestion(QuestionInfo info);

    /**
     * Tells the renderer to show the statistics supplied
     * @param stats statistics data
     */
    public abstract void showStatistics(List<StatisticsEntry> stats);

    /**
     * Tells the renderer to show the overall statistics for the entire quiz
     * @param stats statistics data
     */
    public abstract void showOverallStatistics(List<StatisticsEntry> stats);

    /**
     * Tells the renderer to clean up any resources it has allocated.
     */
    public abstract void cleanup();
}
