/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.ntnu.idi.lqwebclient.client.gamemode;

import com.google.gwt.event.shared.HandlerManager;
import org.ntnu.idi.lqwebclient.client.presenter.AbstractGameModePresenter;
import org.ntnu.idi.lqwebclient.client.presenter.PlainGamePresenter;
import org.ntnu.idi.lqwebclient.client.service.LQserviceAsync;

/**
 * GameModeFactory for PlainGame, providing instances of PlainGamePresenter
 * @author avenger/erlingbo
 */
public class PlainGameFactory implements IGameModeFactory {

    public PlainGameFactory() {
        
    }

    /**
     * Returns the String ID of this game mode
     * @return String representation of the game mode ID
     */
    public String getGameModeID() {
        //Important that this matches the id of the game mode on the server.
        return "PlainGame";
    }

    /**
     * Returns the game mode name
     * @return Game mode name
     */
    public String getGameModeName() {
        return "Plain Game";
    }

    /**
     * Creates an instance of the PlainGamePresenter class
     * @return PlainGamePresenter class instance
     */
    public AbstractGameModePresenter createInstance(LQserviceAsync rpcService, HandlerManager eventBus) {
        return new PlainGamePresenter(rpcService, eventBus);
    }

}
