/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.ntnu.idi.lqwebclient.client.holder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Holder class for an question. Used for sending questions over GWT-RPC
 * @author erlingbo
 */
public class QuestionHolder implements Serializable{
    protected int id;
    protected String text;

    //The current time left of the timeout when the question was provided from the server.
    protected int timeleft;
    //The total timeout for this question
    protected int timeout;
    //List of all answers bellonging to this question
    protected List<AnswerHolder> answers;

    public int getId() {
        return id;
    }

    public void setId(int value) {
        this.id = value;
    }

    public String getText() {
        return text;
    }

    public void setText(String value) {
        this.text = value;
    }

    /**
     * @return The answers bellonging to this question
     */
    public List<AnswerHolder> getAnswers() {
        if (answers == null) {
            answers = new ArrayList<AnswerHolder>();
        }
        return this.answers;
    }

    /**
     * @return The total timeout for this question
     */
    public int getTimeout() {
        return timeout;
    }

    public void setTimeout(int value) {
        this.timeout = value;
    }

    /**
     *
     * @return The current time left of the timeout when the question was provided from the server.
     */
    public int getTimeleft() {
        return timeleft;
    }

    public void setTimeleft(int value) {
        this.timeleft = value;
    }

}
