/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.ntnu.idi.lqwebclient.client.view;

import com.google.gwt.event.logical.shared.CloseHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FocusWidget;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import org.ntnu.idi.lqwebclient.client.presenter.LogInPresenter;

/**
 *
 * @author erlingbo
 */
public class LogInView extends Composite implements LogInPresenter.Display{

    protected TextBox usernameBox;
    protected TextBox quizCodeBox;
    protected final Button logInButton;
    protected DialogBox errorBox;
    protected int currentState;



    public LogInView(){
        VerticalPanel vPanel = new VerticalPanel();
        FlexTable ftable = new FlexTable();
        initWidget(vPanel);


        Label header = new Label("Welcome to LectureQuiz");
        header.addStyleName("Header");


        Label usernameLabel = new Label("Username");
        usernameBox = new TextBox();
        ftable.setWidget(0, 0, usernameLabel);
        ftable.setWidget(0, 1, usernameBox);


        Label quizCodeLabel = new Label("Quizcode");
        quizCodeBox = new TextBox();

        ftable.setWidget(1, 0, quizCodeLabel);
        ftable.setWidget(1, 1, quizCodeBox);

        logInButton = new Button("Join Quiz");
        vPanel.add(header);
        vPanel.add(ftable);
        vPanel.add(logInButton);
    }

    public FocusWidget getLogInButton(){
        return logInButton;
    }
    public HasValue<String> getQuizCode(){
        return quizCodeBox;
    }
    public HasValue<String> getUsername(){
        return usernameBox;
    }

    public Widget asWidget() {
        return this;
    }

    public void displayError(String errorCaption, String errorMessage, CloseHandler handler){
        errorBox = new DialogBox(true, true);
        errorBox.setText(errorCaption);
        errorBox.add(new Label(errorMessage));
        if (handler != null){
            errorBox.addCloseHandler(handler);
        }
        //errorBox.setStyleName("errorbox");
        errorBox.setGlassEnabled(true);
        errorBox.setAnimationEnabled(true);
        errorBox.setPopupPosition(10, 10);
        errorBox.show();
    }

    public void setState(int state){
        if (state == LOGIN_STATE){
            usernameBox.setEnabled(true);
            usernameBox.setText("");
        }
        else if (state == JOINQUIZ_STATE){
            usernameBox.setEnabled(false);
        }
    }

    public int getState(){
        return this.currentState;
    }
}
