/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.ntnu.idi.lqwebclient.client.view;

import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.FocusWidget;
import com.google.gwt.user.client.ui.Grid;
import com.google.gwt.user.client.ui.HasText;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.PushButton;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import org.ntnu.idi.lqwebclient.client.presenter.PlainGamePresenter;
import com.google.gwt.event.logical.shared.CloseHandler;
import com.google.gwt.user.client.ui.Image;

/**
 *
 * @author erlingbo
 */
public class PlainGameView extends Composite implements PlainGamePresenter.Display{
    protected Label question;
    protected PushButton answerA;
    protected PushButton answerB;
    protected PushButton answerC;
    protected PushButton answerD;
    protected DialogBox errorBox;
    protected Label loadingLabel;
    protected Label statisticsLabel;
    protected int state;
    protected Grid answerGrid;
    protected PushButton endStatisticsButton;

    public PlainGameView(){
        VerticalPanel vPanel = new VerticalPanel();
        initWidget(vPanel);

        question = new Label("What is the question?");
        Image imgA = new Image("images/Button_red.png");
        imgA.setPixelSize(40, 40);
        Image imgB = new Image("images/Button_green.png");
        imgB.setPixelSize(40, 40);
        Image imgC = new Image("images/Button_blue.png");
        imgC.setPixelSize(40, 40);
        Image imgD = new Image("images/Button_orange.png");
        imgD.setPixelSize(40, 40);
        answerA = new PushButton(imgA);
        answerB = new PushButton(imgB);
        answerC = new PushButton(imgC);
        answerD = new PushButton(imgD);

        loadingLabel = new Label();
        statisticsLabel = new Label();
        endStatisticsButton = new PushButton("Click to show overall statistics");

        answerGrid = new Grid(2, 2);
        answerGrid.setWidget(0, 0, answerA);
        answerGrid.setWidget(0, 1, answerB);
        answerGrid.setWidget(1, 0, answerC);
        answerGrid.setWidget(1, 1, answerD);

        vPanel.add(question);
        vPanel.add(answerGrid);
        vPanel.add(loadingLabel);
        vPanel.add(statisticsLabel);
        vPanel.add(endStatisticsButton);

        setState(LOADING_STATE);
        loadingLabel.setText("Waiting for instructions from Presenter");

    }

    public FocusWidget getAnswerAButton(){ return answerA; }
    public FocusWidget getAnswerBButton(){ return answerB; }
    public FocusWidget getAnswerCButton(){ return answerC; }
    public FocusWidget getAnswerDButton(){ return answerD; }
    public HasText getQuestionText(){ return question; }
    public FocusWidget getEndStatisticsButton() { return endStatisticsButton; }

    public Widget asWidget() {
        return this;
    }
    public void displayError(String errorCaption, String errorMessage, CloseHandler handler){
        errorBox = new DialogBox(true, true);
        errorBox.setText(errorCaption);
        errorBox.add(new Label(errorMessage));
        if (handler != null){
            errorBox.addCloseHandler(handler);
        }
        //errorBox.setStyleName("errorbox");
        errorBox.setGlassEnabled(true);
        errorBox.setAnimationEnabled(true);
        errorBox.setPopupPosition(10, 10);
        errorBox.show();
    }

    public void setLoadingText(String text) {
        this.loadingLabel.setText(text);
    }

    public void setState(int state) {
        if (this.state == state){
            return;
        }
        if (state == LOADING_STATE){
            question.setVisible(false);
            answerGrid.setVisible(false);
            statisticsLabel.setVisible(false);
            loadingLabel.setVisible(true);
            endStatisticsButton.setVisible(false);
        }

        else if (state == QUESTION_STATE){
            question.setVisible(true);
            answerGrid.setVisible(true);
            statisticsLabel.setVisible(false);
            loadingLabel.setVisible(false);
            endStatisticsButton.setVisible(false);
        }
        else if (state == STATISTICS_STATE){
            question.setVisible(false);
            answerGrid.setVisible(false);
            statisticsLabel.setVisible(true);
            loadingLabel.setVisible(false);
            endStatisticsButton.setVisible(false);
        }
        else if (state == STATISTICS_END_STATE){
            question.setVisible(false);
            answerGrid.setVisible(false);
            statisticsLabel.setVisible(true);
            loadingLabel.setVisible(false);
            endStatisticsButton.setVisible(true);
        }
        else if (state == STATISTICS_OVERALL_STATE){
            question.setVisible(false);
            answerGrid.setVisible(false);
            statisticsLabel.setVisible(true);
            loadingLabel.setVisible(false);
            endStatisticsButton.setVisible(false);
        }

        this.state = state;
    }
    public void setStatistics(String text, int type){
        if (type == STATISTICS_GOOD){
            statisticsLabel.setStyleName("statistics_good");
        }
        else if (type == STATISTICS_BAD){
            statisticsLabel.setStyleName("statistics_bad");
        }
        statisticsLabel.setText(text);


    }


}
