/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.ntnu.idi.lqwebclient.server;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.InvalidPropertiesFormatException;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author avenger
 */
public class ConfigurationManager {
    private static ConfigurationManager _instance = null;

    // The preferences object used to store configurations on the computer
    private Properties props;

    // Keys used in the configration file
    private static final String LQ_SERVER_URL = "LQServerURL";
    private static final String SESSION_TIMEOUT_INTERVAL = "SessionTimeoutInterval";

    private ConfigurationManager() {

        props = new Properties();
        
        try {
            InputStream is = this.getClass().getResourceAsStream("/configuration.xml");

            if(is != null) {
                props.loadFromXML(is);
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ConfigurationManager.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InvalidPropertiesFormatException ex) {
            Logger.getLogger(ConfigurationManager.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(ConfigurationManager.class.getName()).log(Level.SEVERE, null, ex);
        }

        // Load all variables
        lqServerURL = props.getProperty(LQ_SERVER_URL, "http://localhost:8084/LectureQuiz/LectureQuizService?wsdl");
        sessionTimeoutInterval = Integer.parseInt(props.getProperty(SESSION_TIMEOUT_INTERVAL, "1800"));
    }

    /**
     * Get an instance of the configuration settings
     * @return
     */
    public static synchronized ConfigurationManager getInstance() {
        if(_instance == null)
            _instance = new ConfigurationManager();
        return _instance;
    }

    private String lqServerURL;
    public String getLQServerURL() {
        return lqServerURL;
    }

    public void setLQServerURL(String url) {
        lqServerURL = url;
    }

    private int sessionTimeoutInterval;
    public int getSessionTimeoutInterval() {
        return sessionTimeoutInterval;
    }

    public void setSessionTimeoutInterval(int interval) {
        sessionTimeoutInterval = interval;
    }
}

