/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.ntnu.idi.lqwebclient.server;

import org.ntnu.idi.lqwebclient.client.holder.UserHolder;
import org.ntnu.idi.lqwebclient.shared.LectureQuizService;

/**
 * User object holding information on the users that are loged in.
 * Most important is the service port in which communication to the LQService are provided.
 * @author erlingbo
 */
public class User {
    protected LectureQuizService port;
    protected String username;

    public User(){
        
    }
    public User(String username, LectureQuizService port){
        this.username = username;
        this.port = port;
    }
    public String getUsername(){
        return username;
    }
    public LectureQuizService getPort() {
        return port;
    }

    /**
     * Generates a UserHolder that is supported for transfer over the GWT-RPC
     * @return A UserHolder representing this User
     */
    public UserHolder asUserHolder(){
        UserHolder uh = new UserHolder();
        uh.setUsername(this.username);
        return uh;
    }
}
