/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lecturequiz.server.data;

import java.util.ArrayList;
import lecturequiz.server.service.FullQuestionInfo;
import lecturequiz.server.service.FullQuizInfo;
import lecturequiz.server.service.QuestionInfo;

/**
 *
 * @author erlingbo
 */
public class Quiz {
    private int id;
    private String name;
    private ArrayList<Question> questions;
    private String description;

    private User owner;

    public Quiz(int id, String name, String description, 
            ArrayList<Question> questions, User owner) {
        this.id = id;
        this.name = name;
        this.description = description;
        this.questions = (ArrayList<Question>)questions.clone();
        this.owner = owner;
    }

    /**
     * Returns the ID of the quiz
     * @return ID of the quiz.
     */
    public int getId() {
        return id;
    }

    /**
     * Get the name of the quiz.
     * @return name of the quiz.
     */
    public String getName() {
        return name;
    }

    public int getNumberOfQuestions(){
        return questions.size();
    }

    public ArrayList<Question> getQuestions(){
        return questions;
    }

    public FullQuizInfo toFullQuizInfo() {
        FullQuizInfo fqi = new FullQuizInfo();

        fqi.id = id;
        fqi.name = name;
        fqi.description = description;
        fqi.owner = owner.getNickname();
        fqi.questions = new ArrayList<FullQuestionInfo>();

        for(int i = 0; i < questions.size(); i++) {
            QuestionInfo qi = questions.get(i).getQuestionInfo();
            FullQuestionInfo fq = new FullQuestionInfo();
            fq.answers = qi.answers;
            fq.id = qi.id;
            fq.text = qi.text;
            fq.timeleft = qi.timeleft;
            fq.timeout = qi.timeout;
            fq.correctAnswer = questions.get(i).getCorrectAnswer();
            fqi.questions.add(fq);
        }

        return fqi;
    }

}
