/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lecturequiz.server.data;

import lecturequiz.server.gamemodes.AbstractGameMode;

/**
 *
 * @author erlingbo
 */
public class User {

    // User roles //
    public static final int ADMIN = 1;
    public static final int TEACHER = 2;
    public static final int STUDENT = 3;
    // UserRoles //

    private int id;
    private String nickname;
    private int role;
    private boolean authenticated;

    // The current game this user is connected to
    private AbstractGameMode currentGame;

    public User(int id, String nickname, int role){
        this.id = id;
        this.nickname = nickname;
        this.role = role;
    }

    public User(String nickname, int role) {
        this(-1,nickname,role);
    }

    public String getNickname(){
        return nickname;
    }

    public int getRole() {
        return role;
    }

    /**
     * Returns the ID of the user.
     * @return the ID of the user.
     */
    public int getId() {
        return id;
    }

    /**
     * Returns the current game this user is connected to.
     * @return The current game this user is connected to.
     */
    public AbstractGameMode getCurrentGame() {
        return currentGame;
    }

    /**
     * Sets the current game this user is connected to.
     * @param game The game this user is conencted to.
     */
    public void setCurrentGame(AbstractGameMode game) {
        currentGame = game;
    }
}
