/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lecturequiz.server.service;

import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;
import lecturequiz.server.data.User;
import lecturequiz.server.main.ConfigurationManager;
import lecturequiz.server.main.UserManager;

/**
 *
 * @author avenger
 */
public class SessionManager implements HttpSessionListener {
    /**
     * Dummy method to handle session creation, we don't need to do anything here
     * @param se
     */
    public void sessionCreated(HttpSessionEvent se) {

        // Test value
        se.getSession().setMaxInactiveInterval(ConfigurationManager.getInstance().getSessionTimeoutInterval());
    }

    /**
     * Handles the destruction of a session
     * @param se
     */
    public void sessionDestroyed(HttpSessionEvent se) {

        // Remove the user from any games it participates in, and
        // remove them from the users list
        User user = (User)se.getSession().getAttribute("User");
        if(user == null)
            return;

        UserManager.getInstance().removeUser(user);
    }
}
